var LC_AddBookmark2 =
{
	// Initialization Code
	startup : function ()
	{
		var sFeed = gArg.feedURL;

		// Make no changes if new bookmark has no feed URL
		if (!sFeed || sFeed == "") return;

		// If location empty or same as feed, update location
		if (gArg.url == "" || gArg.url == sFeed)
			LC_AddBookmark2.updateLocation();

		// Get localized strings
		var strings = document.getElementById( "liveclick-strings" );

		// Create Monitor checkbox
		var cbMonitor = document.createElementNS( gXUL_NS, "checkbox" );
		cbMonitor.setAttribute( "id", "liveclick-monitor" );
		cbMonitor.setAttribute( "initstate", false );
		cbMonitor.setAttribute( "checked", false );
		cbMonitor.setAttribute( "label", strings.getString( "propsMonitor" ) );

		// Insert as last element
		var treeFolder = document.getElementById( "folder-tree" );
		treeFolder.parentNode.appendChild( cbMonitor );

		sizeToContent();

		window.addEventListener( "dialogaccept", LC_AddBookmark2.accept, true );
	},

	// Tell browser windows to update list of notifiables
	accept : function ()
	{
		// Do nothing if new bookmark has no feed URL
		var sFeed = gArg.feedURL;
		if (!sFeed || sFeed == "") return;

		// Do nothing if monitor not checked
		var cbMonitor = document.getElementById( "liveclick-monitor" );
		if (cbMonitor.checked == false) return;

		NotifiableUtils.updateFile( sFeed, true );

		Components.classes["@mozilla.org/observer-service;1"].
			getService( Components.interfaces.nsIObserverService ).
			notifyObservers( null, "notifiables-add", sFeed );
	},

	// Set url to feed home page
	updateLocation : function ()
	{
		// Continue only if Firefox 2.0+
		if (!"@mozilla.org/browser/feeds/result-service;1" in Components.classes)
			return;

		var sFeed = gArg.feedURL;

		var httpRequest = null;

		function infoReceived()
		{
			var data = httpRequest.responseText;

			var ioService = Components.classes["@mozilla.org/network/io-service;1"]
								.getService( Components.interfaces.nsIIOService );
			var uri = ioService.newURI( sFeed, null, null );

			if (data.length)
			{
				var parser = Components.classes["@mozilla.org/feed-processor;1"]
								.createInstance( Components.interfaces.nsIFeedProcessor );
				var listener = new FeedLinkListener();
				try
				{
					parser.listener = listener;
					parser.parseFromString( data, uri );
				}
				catch(e) { }
			}
		}

		httpRequest = new XMLHttpRequest();

		httpRequest.open( "GET", sFeed, true );
		try
		{
			httpRequest.onload = infoReceived;
			httpRequest.send( null );
		}
		catch(e) { }
	}
}

function FeedLinkListener ()
{
}

FeedLinkListener.prototype =
{
	handleResult : function (result)
	{
		var feed = result.doc;
		feed.QueryInterface( Components.interfaces.nsIFeed );
		gArg.url = getNormalizedURL( feed.link.spec );
	}
}

window.addEventListener( "load", function() { LC_AddBookmark2.startup(); }, false );