// Livemark favicon class (added 0.1.6)
var LiveIconsUtils =
{
	// Show favicons for livemarks in bookmarks menu
	showInMenu : function (aTarget)
	{
		if (!aTarget.hasChildNodes) return; // empty menu

		// Generate list of livemarks in bookmarks menu
		var nodeList =
			aTarget.getElementsByAttribute( "type", "http://home.netscape.com/NC-rdf#Livemark" );
		LiveIconsUtils.iconifyList( nodeList );
	},

	// Go through all bookmark items in menu/toolbar
	iconifyList : function (aNodes)
	{
		for (var i = 0; i < aNodes.length; i++)
			LiveIconsUtils.iconifyItem( aNodes[i] );
	},

	// Draw toolbar button icon (added 0.1.6)
	// Listener trigged when new item added to bookmarks toolbar
	// Specifically, draws icon when:
	//  1) Livemark button is moved anywhere on the toolbar
	//  2) New bookmark inserted at any point before it
	//  3) Existing bookmark is moved to any point before it
	// TODO: Call function when toolbar resized, moved, or customized
	iconifyButton : function (aEvent)
	{
		var target = aEvent.target;

		// Break out if inserting non-bookmark item
		if (!target.id) return;

		// Draw favicon if toolbar button
		if (target.localName == "toolbarbutton")
			LiveIconsUtils.iconifyItem( target );
	},

	// Replace RSS icon with favicon for a livemark item
	// Revised for use on both menus and bookmarks toolbar (0.1.6)
	iconifyItem : function (aTarget)
	{
		var sType = BookmarksUtils.resolveType( aTarget.id );
		if (sType == "Livemark")
		{
			var sLocal = aTarget.localName;

			var resource = RDF.GetResource( aTarget.id );
			var icon = BookmarksUtils.getProperty( resource, gNC_NS + "Icon" );

			var bShowFavIcons = LC_Prefs.getValue( "showFavIcons" );

			if (icon && bShowFavIcons)
			{
				// If favicon available and enabled, use in place of RSS icon
				if (sLocal == "toolbarbutton")
					// Set liveclick-toolbarbutton class for dropmarker + icon dimensions
					aTarget.setAttribute( "class", "liveclick-toolbarbutton" );
				else
					// Add liveclick-bookmark class so icons show at 16x16 pixels max
					// No menu-iconic class, no icon whatsoever
					aTarget.setAttribute( "class", "bookmark-item menu-iconic liveclick-bookmark" );

				aTarget.setAttribute( "image", icon );
			}
			else
			{
				// Set default attributes to restore default icon
				if (sLocal == "toolbarbutton")
					aTarget.setAttribute( "class", "bookmark-item" );
				else
					aTarget.setAttribute( "class", "bookmark-item menu-iconic" );

				aTarget.setAttribute( "image", "" );
			}
		}
	}
}