// Global variables
var gLC_History;		// Global History service
var gLC_BHistory;		// Browser History service

// LiveClick History object
var LC_History =
{
	// Initialization code
	startup : function ()
	{
		gLC_History = Components.classes["@mozilla.org/browser/global-history;2"].
						getService( Components.interfaces.nsIGlobalHistory2 );

		gLC_BHistory = Components.classes["@mozilla.org/browser/global-history;2"].
						getService( Components.interfaces.nsIBrowserHistory );
	},

	// Tests for URI in history
	isVisited : function (aURI)
	{
		if (!aURI) return false;	// Return false if invalid uri
		return gLC_History.isVisited( aURI );
	},

	// Add to history to simulate "mark as read"
	// Then use hidePage so it doesn't show up in UI
	markAsRead : function (aURI)
	{
		if (!aURI) return;	// Abort if invalid uri
		gLC_History.addURI( aURI, false, false, null );
		gLC_BHistory.hidePage( aURI );
	},

	// Remove from history to simulate "unread"
	markAsUnread : function (aURI)
	{
		if (!aURI) return;	// Abort if invalid uri
		gLC_BHistory.removePage( aURI );
	}
}

// Register LiveClick as an onLoad listener. To avoid getting called
// multiple times, register in non-capturing mode (3rd param = false).
window.addEventListener( "load", function() { LC_History.startup(); }, false );