var LC_Prefs =
{
	// Constants
	PREF_BASE : "extensions.liveclick.",

	// Class properties
	service : null,
	values : null,
	types : null,

	startup : function ()
	{
		this.values =
		{
			"onLeftClick" : null,
			"onMiddleClick" : null,
			"onAccelClick" : null,
			"showFavIcons" : null,
			"showPopupOpen" : null,
			"showPopupFeed" : null,
			"showPopupRead" : null,
			"showAtTop" : null,
			"maxFeedItems" : null,
			"readStyle" : null,
			"monitorAction" : null,
			"alert1Action" : null,
			"alert1Read" : null,
			"alertNAction" : null,
			"alertNRead" : null,
			"alertForeground" : null,
			"autoload1Action" : null,
			"autoload1Read" : null,
			"autoloadNAction" : null,
			"autoloadNRead" : null,
			"promptNoLocation" : null
		};

		this.types =
		{
			"onLeftClick" : "int",
			"onMiddleClick" : "int",
			"onAccelClick" : "int",
			"showFavIcons" : "bool",
			"showPopupOpen" : "bool",
			"showPopupFeed" : "bool",
			"showPopupRead" : "bool",
			"showAtTop" : "int",
			"maxFeedItems" : "int",
			"readStyle" : "int",
			"monitorAction" : "int",
			"alert1Action" : "int",
			"alert1Read" : "bool",
			"alertNAction" : "int",
			"alertNRead" : "bool",
			"alertForeground" : "bool",
			"autoload1Action" : "int",
			"autoload1Read" : "bool",
			"autoloadNAction" : "int",
			"autoloadNRead" : "bool",
			"promptNoLocation" : "bool"
		};

		this.service = Components.classes["@mozilla.org/preferences-service;1"].
						getService( Components.interfaces.nsIPrefService ).
						getBranch( this.PREF_BASE );

		this.service.QueryInterface( Components.interfaces.nsIPrefBranch2 );
		this.service.addObserver( "", this, false );

		window.addEventListener( "unload", function() { LC_Prefs.shutdown(); }, false );
	},

	shutdown : function ()
	{
		this.service.removeObserver( "", this );
	},

	observe : function (aSubject, aTopic, aData)
	{
		if (aTopic != "nsPref:changed") return;
		this.values[aData] = this.getPreference( aData );
	},

	getValue : function (aName)
	{
		if (this.values[aName] == null)
			this.values[aName] = this.getPreference( aName );

		return this.values[aName];
	},

	getPreference : function (aName)
	{
		var value = null;
		var sType = this.types[aName];

		try
		{
			switch (sType)
			{
				case "bool":
					value = this.service.getBoolPref( aName );
					break;
				case "int":
					value = this.service.getIntPref( aName );
					break;
				default:
					value = this.service.getCharPref( aName );
					break;
			}
		}
		catch (e)
		{
			// Do Nothing
		}

		return value;
	},

	setPreference : function (aName, aValue)
	{
		var sType = this.types[aName];

		try
		{
			switch (sType)
			{
				case "bool":
					this.service.setBoolPref( aName, aValue );
					break;
				case "int":
					this.service.setIntPref( aName, aValue );
					break;
				default:
					this.service.setCharPref( aName, aValue );
					break;
			}
			this.values[aName] = aValue;
		}
		catch (e)
		{
			// Do Nothing
		}
	}
}

// Register LC_Prefs as an onLoad listener. To avoid getting called
// multiple times, register in non-capturing mode (3rd param = false).
window.addEventListener( "load", function() { LC_Prefs.startup(); }, false );